## pytango 9.3.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
set(CMP0048 NEW)

project(_tango LANGUAGES CXX)

# Set PROJECT_VERSION and PACKAGE_VERSION from git tags
include(cmake/project_version.cmake)

if(NOT WIN32)
  message(FATAL_ERROR "This file is only targeting Windows builds - aborting!")
endif(NOT WIN32)

add_definitions(-DWIN32)
add_definitions(-DNDEBUG)
add_definitions(-D_WINSTATIC)
add_definitions(-DNPY_NO_DEPRECATED_API)
add_definitions(-DBOOST_PYTHON_STATIC_LIB)
add_definitions(-DBOOST_ALL_NO_LIB)
add_definitions(-DZMQ_STATIC)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(PY_TARGET "64")
  add_definitions(-D_64BITS)
  if(MSVC14)
    add_definitions(-D_TIMERS_T_)
  endif(MSVC14)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(PY_TARGET "32")
  add_definitions(-DJPG_USE_ASM)
else(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(FATAL_ERROR "Unknown architecture - aborting!")
endif(CMAKE_SIZEOF_VOID_P EQUAL 8)

set(SOURCES
        ext/api_util.cpp
        ext/archive_event_info.cpp
        ext/server/attr.cpp
        ext/attr_conf_event_data.cpp
        ext/server/attribute.cpp
        ext/server/auto_monitor.cpp
        ext/attribute_alarm_info.cpp
        ext/attribute_dimension.cpp
        ext/attribute_event_info.cpp
        ext/attribute_info.cpp
        ext/attribute_info_ex.cpp
        ext/attribute_proxy.cpp
        ext/base_types.cpp
        ext/callback.cpp
        ext/change_event_info.cpp
        ext/server/command.cpp
        ext/command_info.cpp
        ext/connection.cpp
        ext/constants.cpp
        ext/data_ready_event_data.cpp
        ext/database.cpp
        ext/db.cpp
        ext/dev_command_info.cpp
        ext/dev_error.cpp
        ext/device_attribute.cpp
        ext/device_attribute_config.cpp
        ext/device_attribute_history.cpp
        ext/server/device_class.cpp
        ext/device_data.cpp
        ext/device_data_history.cpp
        ext/server/device_impl.cpp
        ext/device_info.cpp
        ext/device_pipe.cpp
        ext/device_proxy.cpp
        ext/devintr_change_event_data.cpp
        ext/server/dserver.cpp
        ext/server/encoded_attribute.cpp
        ext/enums.cpp
        ext/event_data.cpp
        ext/exception.cpp
        ext/from_py.cpp
        ext/server/fwdAttr.cpp
        ext/group.cpp
        ext/group_reply.cpp
        ext/group_reply_list.cpp
        ext/locker_info.cpp
        ext/locking_thread.cpp
        ext/server/log4tango.cpp
        ext/server/multi_attribute.cpp
        ext/server/multi_class_attribute.cpp
        ext/periodic_event_info.cpp
        ext/server/pipe.cpp
        ext/pipe_event_data.cpp
        ext/pipe_info.cpp
        ext/poll_device.cpp
        ext/precompiled_header.cpp
        ext/pytango.cpp
        ext/pytgutils.cpp
        ext/pyutils.cpp
        ext/server/subdev.cpp
        ext/server/tango_util.cpp
        ext/time_val.cpp
        ext/to_py.cpp
        ext/server/user_default_attr_prop.cpp
        ext/server/user_default_pipe_prop.cpp
        ext/version.cpp
        ext/server/wattribute.cpp)

set(HEADERS
        ext/precompiled_header.hpp
        ext/base_types_numpy.hpp
        ext/fast_from_py_numpy.hpp
        ext/server/wattribute_numpy.hpp
        ext/device_attribute_numpy.hpp
        ext/to_py_numpy.hpp
        ext/server/attr.h
        ext/server/attribute.h
        ext/callback.h
        ext/server/command.h
        ext/defs.h
        ext/device_attribute.h
        ext/server/device_class.h
        ext/server/device_impl.h
        ext/device_pipe.h
        ext/exception.h
        ext/fast_from_py.h
        ext/from_py.h
        ext/server/pipe.h
        ext/pytgutils.h
        ext/pyutils.h
        ext/tango_numpy.h
        ext/tgutils.h
        ext/to_py.h)

set(${PROJECT_NAME} INCLUDE_DIRS "$ENV{TANGO_ROOT}/include")

if(MSVC90)
  # v9 used for Python 2
  set(VCSTR "90")
  set(BOOST_VERSION_ "1_70")
elseif(MSVC14)
  # v14 used for Python 3
  set(VCSTR "140")
  set(BOOST_VERSION_ "1_73")
endif()
set(ZMQ_VERSION_ "4_0_5")

set(RELEASE "Release_$ENV{PYTHON_VER}_${PY_TARGET}")
include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/ext")
include_directories(${PROJECT_NAME} PUBLIC "$ENV{BOOST_ROOT}/include/boost-${BOOST_VERSION_}")
include_directories(${PROJECT_NAME} PUBLIC "$ENV{PYTHON_ROOT}/include")
include_directories(${PROJECT_NAME} PUBLIC "$ENV{TANGO_ROOT}/include")
include_directories(${PROJECT_NAME} PUBLIC "$ENV{PYTHON_ROOT}/Lib/site-packages/numpy/core/include")
link_directories("$ENV{TANGO_ROOT}/bin")
link_directories("$ENV{TANGO_ROOT}/lib")
link_directories("$ENV{PYTHON_ROOT}/libs")
link_directories("$ENV{BOOST_ROOT}/lib")
message("TANGO at: $ENV{TANGO_ROOT}")
message("BOOST at: $ENV{BOOST_ROOT}")
message("PYTHON at: $ENV{PYTHON_ROOT}")
message("Release at: ${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}")
add_compile_options(/MT)
add_library(${PROJECT_NAME} SHARED ${SOURCES} ${HEADERS})
target_compile_options(${PROJECT_NAME} PUBLIC "/MT")
set_target_properties( ${PROJECT_NAME}
  PROPERTIES
  SUFFIX ".pyd" )
set_target_properties(${PROJECT_NAME}
  PROPERTIES
  COMPILE_OPTIONS "MT" )
set_target_properties(${PROJECT_NAME}
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}/tango"
  LIBRARY_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}/tango"
  RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}/tango")

if(MSVC90 AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
  # resolve VC 9 64bits complains
  set_source_files_properties(ext/base_types.cpp PROPERTIES COMPILE_FLAGS /bigobj)
endif()

add_custom_command(TARGET ${PROJECT_NAME}
  POST_BUILD
  COMMAND "$ENV{PYTHON_ROOT}/python.exe"  ARGS "${CMAKE_CURRENT_SOURCE_DIR}/winsetup.py" ${RELEASE} dist temp_dist $(ConfigurationName) $(PlatformName)
  COMMENT "Building installer")


install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin)

set_property(TARGET ${PROJECT_NAME} PROPERTY COMPILE_OPTIONS "/bigobj")
set_property(TARGET ${PROJECT_NAME} PROPERTY COMPILE_OPTIONS "/MT")
set_property(TARGET ${PROJECT_NAME} PROPERTY LINK_FLAGS "/LTCG /force:multiple /DYNAMICBASE:NO /OPT:REF /OPT:ICF /SUBSYSTEM:WINDOWS")
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/libtango.lib
                                             $ENV{TANGO_ROOT}/lib/omniORB4.lib
                                             $ENV{TANGO_ROOT}/lib/omniDynamic4.lib
                                             $ENV{TANGO_ROOT}/lib/COS4.lib
                                             $ENV{TANGO_ROOT}/lib/omnithread.lib)
target_link_libraries(${PROJECT_NAME} PUBLIC ws2_32 mswsock advapi32 comctl32 odbc32)
target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/pthreadVC2.lib)
target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/libzmq-v${VCSTR}-mt-s-${ZMQ_VERSION_}.lib)
target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{BOOST_ROOT}/lib/libboost_python$ENV{PYTHON_VER}-vc${VCSTR}-mt-s-x${PY_TARGET}-${BOOST_VERSION_}.lib)
target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{PYTHON_ROOT}/libs/python$ENV{PYTHON_VER}.lib)

=== Makefile ===
# ------------------------------------------------------------------------------
# This file is part of PyTango (http://pytango.rtfd.io)
#
# Copyright 2006-2012 CELLS / ALBA Synchrotron, Bellaterra, Spain
# Copyright 2013-2014 European Synchrotron Radiation Facility, Grenoble, France
#
# Distributed under the terms of the GNU Lesser General Public License,
# either version 3 of the License, or (at your option) any later version.
# See LICENSE.txt for more info.
# ------------------------------------------------------------------------------

################################################################################
#                    TO BE USED BY DEVELOPERS ONLY
################################################################################

# Makefile to generate the PyTango library
# Needs the following environment variables to be defined:
# - TANGO_ROOT
# - LOG4TANGO_ROOT
# - OMNI_ROOT
# - BOOST_ROOT
# - ZMQ_ROOT
# - NUMPY_ROOT
#
# if target == install also needs: prefix=<install_dir>
# ex: make install prefix=/home/homer/.local/lib/python2.6/site-packages
#
# Optional:
# - OBJS_DIR: directory where files will be build (default: objs)
# - PY3K: if defined use python 3 boost python
# - PY_VER: use a specific python version (default is empty) (ex: 3.2)

# Build "in parallel":
# make prepare && make -j5
#
# Install "in parallel":
# make prepare && make -j5 && make install prefix=<install dir>

ifdef PY_VER
PY_EXC=python$(PY_VER)
PY_MAJOR=$(shell $(PY_EXC) -c "import sys; sys.stdout.write(str(sys.version_info[0]))")
PY_MINOR=$(shell $(PY_EXC) -c "import sys; sys.stdout.write(str(sys.version_info[1]))")
else
PY_EXC=python
PY_MAJOR=$(shell $(PY_EXC) -c "import sys; sys.stdout.write(str(sys.version_info[0]))")
PY_MINOR=$(shell $(PY_EXC) -c "import sys; sys.stdout.write(str(sys.version_info[1]))")
PY_VER=$(PY_MAJOR).$(PY_MINOR)
endif

PY_VER_S=$(PY_MAJOR)$(PY_MINOR)

ifndef NUMPY_ROOT
NUMPY_INC = -I$(shell $(PY_EXC) -c "import sys, numpy; sys.stdout.write(numpy.get_include())")
else
NUMPY_INC = -I$(NUMPY_ROOT)/include
endif

PYTANGO_NUMPY_VERSION = $(shell $(PY_EXC) -c "import sys, numpy; sys.stdout.write(numpy.__version__)")

ifndef prefix
ifdef user
_PY_DIR=$(shell $(PY_EXC) -c "import sys, os; sys.stdout.write(os.path.split(os.path.join(os.path.dirname(os.__file__)))[1])")
prefix=$(HOME)/.local/lib/$(_PY_DIR)/site-packages
else
_PY_DIR=$(shell $(PY_EXC) -c "import sys, os; sys.stdout.write(os.path.join(os.path.dirname(os.__file__)))")
prefix=$(_PY_DIR)/site-packages
endif
endif

SRC_DIR = ext

ifndef OBJS_DIR
OBJS_DIR := objs_py$(PY_VER_S)
endif

CC = gcc

PY_INC := $(shell python$(PY_VER)-config --includes)

ifdef optimize
OPTIMIZE_CC = -O2
OPTIMIZE_LN = -O2
else
OPTIMIZE_CC = -O0
OPTIMIZE_LN = -O0
endif

TANGO_CFLAGS=`pkg-config --cflags-only-other tango`
TANGO_LIBS=`pkg-config --libs-only-l tango`

ifdef CONDA_PREFIX
BOOST_LIB = boost_python
else
BOOST_LIB = boost_python-py$(PY_VER_S)
endif

PRE_C_H := precompiled_header.hpp
PRE_C_H_O := $(OBJS_DIR)/$(PRE_C_H).gch
PRE_C := -include$(OBJS_DIR)/$(PRE_C_H)

LN := g++ -pthread -shared -Wl,$(OPTIMIZE_LN) -Wl,-Bsymbolic-functions #-z defs
LN_STATIC := g++ -pthread -static -Wl,$(OPTIMIZE_LN) -Wl,-Bsymbolic-functions

LN_VER := -Wl,-h -Wl,--strip-all

LN_LIBS := -l$(BOOST_LIB) -ltango

INCLUDE_DIRS =

ifdef TANGO_ROOT
LN_DIRS += -L$(TANGO_ROOT)/lib
INCLUDE_DIRS += -I$(TANGO_ROOT)/include -I$(TANGO_ROOT)/include/tango
#LN_LIBS += -ltango -lomniDynamic4 -lCOS4 -llog4tango -lzmq -lomniORB4 -lomnithread
else
LN_DIRS += `pkg-config --libs-only-L tango`
INCLUDE_DIRS += `pkg-config --cflags-only-I tango`
#LN_LIBS += `pkg-config --libs-only-l tango`
endif

ifdef LOG4TANGO_ROOT
LN_DIRS += -L$(LOG4TANGO_ROOT)/lib
INCLUDE_DIRS += -I$(LOG4TANGO_ROOT)/include
endif

ifdef OMNI_ROOT
LN_DIRS += -L$(OMNI_ROOT)/lib
INCLUDE_DIRS += -I$(OMNI_ROOT)/include
endif

ifdef BOOST_ROOT
LN_DIRS += -L$(BOOST_ROOT)/lib
endif

ifdef ZMQ_ROOT
LN_DIRS += -L$(ZMQ_ROOT)/lib
INCLUDE_DIRS += -I$(ZMQ_ROOT)/include
endif

INCLUDE_DIRS += \
    $(PY_INC) \
    $(NUMPY_INC)

QUOTE_INCLUDE_DIRS = -iquote $(SRC_DIR)

MACROS := -DNDEBUG -DPYTANGO_HAS_UNIQUE_PTR -DPYTANGO_NUMPY_VERSION=$(PYTANGO_NUMPY_VERSION)
CFLAGS := -pthread -fno-strict-aliasing -fwrapv -Wall -fPIC -g $(OPTIMIZE_CC) $(MACROS) $(TANGO_CFLAGS) $(INCLUDE_DIRS) $(QUOTE_INCLUDE_DIRS)
LNFLAGS := $(LN_DIRS) $(LN_LIBS)

LIB_NAME := _tango.so
LIB_SYMB_NAME := $(LIB_NAME).dbg

OBJS := \
$(OBJS_DIR)/api_util.o \
$(OBJS_DIR)/archive_event_info.o \
$(OBJS_DIR)/attr_conf_event_data.o \
$(OBJS_DIR)/attribute_alarm_info.o \
$(OBJS_DIR)/attribute_dimension.o \
$(OBJS_DIR)/attribute_event_info.o \
$(OBJS_DIR)/attribute_info.o \
$(OBJS_DIR)/attribute_info_ex.o \
$(OBJS_DIR)/device_pipe.o \
$(OBJS_DIR)/pipe_info.o \
$(OBJS_DIR)/attribute_proxy.o \
$(OBJS_DIR)/base_types.o \
$(OBJS_DIR)/callback.o \
$(OBJS_DIR)/change_event_info.o \
$(OBJS_DIR)/command_info.o \
$(OBJS_DIR)/connection.o \
$(OBJS_DIR)/constants.o \
$(OBJS_DIR)/database.o \
$(OBJS_DIR)/data_ready_event_data.o \
$(OBJS_DIR)/db.o \
$(OBJS_DIR)/dev_command_info.o \
$(OBJS_DIR)/dev_error.o \
$(OBJS_DIR)/device_attribute_config.o \
$(OBJS_DIR)/device_attribute.o \
$(OBJS_DIR)/device_attribute_history.o \
$(OBJS_DIR)/device_data.o \
$(OBJS_DIR)/device_data_history.o \
$(OBJS_DIR)/device_info.o \
$(OBJS_DIR)/devintr_change_event_data.o \
$(OBJS_DIR)/device_proxy.o \
$(OBJS_DIR)/enums.o \
$(OBJS_DIR)/event_data.o \
$(OBJS_DIR)/exception.o \
$(OBJS_DIR)/from_py.o \
$(OBJS_DIR)/fwdAttr.o \
$(OBJS_DIR)/group.o \
$(OBJS_DIR)/group_reply.o \
$(OBJS_DIR)/group_reply_list.o \
$(OBJS_DIR)/locker_info.o \
$(OBJS_DIR)/locking_thread.o \
$(OBJS_DIR)/periodic_event_info.o \
$(OBJS_DIR)/pipe_event_data.o \
$(OBJS_DIR)/poll_device.o \
$(OBJS_DIR)/pytango.o \
$(OBJS_DIR)/pytgutils.o \
$(OBJS_DIR)/pyutils.o \
$(OBJS_DIR)/time_val.o \
$(OBJS_DIR)/to_py.o \
$(OBJS_DIR)/version.o \
$(OBJS_DIR)/attr.o \
$(OBJS_DIR)/attribute.o \
$(OBJS_DIR)/command.o \
$(OBJS_DIR)/pipe.o \
$(OBJS_DIR)/device_class.o \
$(OBJS_DIR)/device_impl.o \
$(OBJS_DIR)/dserver.o \
$(OBJS_DIR)/encoded_attribute.o \
$(OBJS_DIR)/log4tango.o \
$(OBJS_DIR)/multi_attribute.o \
$(OBJS_DIR)/multi_class_attribute.o \
$(OBJS_DIR)/subdev.o \
$(OBJS_DIR)/tango_util.o \
$(OBJS_DIR)/user_default_attr_prop.o \
$(OBJS_DIR)/user_default_pipe_prop.o \
$(OBJS_DIR)/wattribute.o \
$(OBJS_DIR)/auto_monitor.o

INC := callback.h \
defs.h \
device_attribute.h \
exception.h \
fast_from_py.h \
from_py.h \
pytgutils.h \
pyutils.h \
tango_numpy.h \
tgutils.h \
to_py.h \
attr.h \
attribute.h \
command.h \
pipe.h \
device_class.h \
device_impl.h

LINKER=$(LN) $(OBJS) $(LN_VER)

LINK_TASK=link
ifdef optimize
LINK_TASK=link-opt
endif

OK=OK!

#-----------------------------------------------------------------

all: build

prepare: init $(PRE_C_H_O)

build: init prepare $(LINK_TASK)

init:
	@echo Using python $(PY_VER)
	@echo CFLAGS  = $(CFLAGS)
	@echo LNFLAGS = $(LNFLAGS)
	@echo -n "Preparing build directories... "
	@mkdir -p $(OBJS_DIR)
	@echo $(OK)

$(PRE_C_H_O): $(SRC_DIR)/$(PRE_C_H)
	@echo -n "Compiling pre-compiled header... "
	@$(CC) $(CFLAGS) -c $< -o $(PRE_C_H_O)
	@echo $(OK)

#
# Rule for API files
#
$(OBJS_DIR)/%.o: $(SRC_DIR)/%.cpp
	@echo -n "Compiling $(<F)... "
	@$(CC) $(CFLAGS) -c $< -o $(OBJS_DIR)/$*.o $(PRE_C)
	@echo Done!

$(OBJS_DIR)/%.o: $(SRC_DIR)/server/%.cpp
	@echo -n "Compiling $(<F)... "
	@$(CC) $(CFLAGS) -c $< -o $(OBJS_DIR)/$*.o $(PRE_C)
	@echo $(OK)

#
#	The shared libs
#

link: prepare $(OBJS)
	@echo -n "Linking shared $(LIB_NAME)... "
	@$(LINKER) -o $(OBJS_DIR)/$(LIB_NAME) $(LNFLAGS)
	@echo $(OK)

link-opt: link
	@echo Optimizing shared $(LIB_NAME)
	@echo -n "  Building separate debug file... "
	@objcopy --only-keep-debug $(OBJS_DIR)/$(LIB_NAME) $(OBJS_DIR)/$(LIB_NAME).dbg
	@echo $(OK)
	@echo -n "  Stripping $(LIB_NAME)... "
	@objcopy --strip-debug --strip-unneeded $(OBJS_DIR)/$(LIB_NAME)
	@echo $(OK)
	@echo -n "  Linking $(LIB_NAME) with debug file... "
	@objcopy --add-gnu-debuglink=$(OBJS_DIR)/$(LIB_NAME).dbg $(OBJS_DIR)/$(LIB_NAME)
	@echo $(OK)

clean:
	@echo -n Cleaning ...
	@rm -f $(OBJS_DIR)/*.o
	@echo $(OK)

clean-all:
	@echo -n Cleaning all...
	@rm -rf $(OBJS_DIR)
	@echo $(OK)

install-py:
	@echo -n "Installing python files into $(prefix)/tango... "
	@mkdir -p $(prefix)/tango
	@rsync -r tango/ $(prefix)/tango/
	@rsync PyTango.py $(prefix)/
	@echo $(OK)

install-lib:
	@echo -n "Installing binary files into $(prefix)/tango... "
	@rsync $(OBJS_DIR)/$(LIB_NAME) $(prefix)/tango
	@echo $(OK)

install-all: install-py install-lib

install: build install-all

=== examples/pipeEvents/Makefile ===
#=============================================================================
#
# file :        Makefile
#
# description : Makefile to generate a TANGO device server.
#
# project :     PipeServer
#
# $Author:  $
#
# $Revision:  $
# $Date:  $
#
#=============================================================================
#                This file is generated by POGO
#        (Program Obviously used to Generate tango Object)
#=============================================================================
#
#
#=============================================================================
# MAKE_ENV is the path to find common environment to buil project
#
MAKE_ENV = /usr/local/share/pogo/preferences

#=============================================================================
# PACKAGE_NAME is the name of the library/device/exe you want to build
#
PACKAGE_NAME = PipeServer
MAJOR_VERS   = 1
MINOR_VERS   = 0
RELEASE      = Release_$(MAJOR_VERS)_$(MINOR_VERS)

# #=============================================================================
# # RELEASE_TYPE
# # - DEBUG     : debug symbols - no optimization
# # - OPTIMIZED : no debug symbols - optimization level set to O2
# #-----------------------------------------------------------------------------
RELEASE_TYPE = DEBUG

#=============================================================================
# OUTPUT_TYPE can be one of the following :
#   - 'STATIC_LIB' for a static library (.a)
#   - 'SHARED_LIB' for a dynamic library (.so)
#   - 'DEVICE' for a device server (will automatically include and link
#            with Tango dependencies)
#   - 'SIMPLE_EXE' for an executable with no dependency (for exemple the test tool
#                of a library with no Tango dependencies)
#
OUTPUT_TYPE = DEVICE

#=============================================================================
# OUTPUT_DIR  is the directory which contains the build result.
# if not set, the standard location is :
#	- ./shlib if OUTPUT_TYPE is SHARED_LIB
#	- ./lib   if OUTPUT_TYPE is STATIC_LIB
#	- ./bin for others
#
#OUTPUT_DIR =


#=============================================================================
# INC_DIR_USER is the list of all include path needed by your sources
#   - for a device server, tango dependencies are automatically appended
#   - '-I ../include' and '-I .' are automatically appended in all cases
#
INC_DIR_USER= -I .

#=============================================================================
# LIB_DIR_USER is the list of user library directories
#   - for a device server, tango libraries directories are automatically appended
#   - '-L ../lib' is automatically appended in all cases
#
#LIB_DIR_USER=

#=============================================================================
# LFLAGS_USR is the list of user link flags
#   - for a device server, tango libraries directories are automatically appended
#   - '-ldl -lpthread' is automatically appended in all cases
#
# !!! ATTENTION !!!
# Be aware that the order matters. 
# For example if you must link with libA, and if libA depends itself on libB
# you must use '-lA -lB' in this order as link flags, otherwise you will get
# 'undefined reference' errors
#
#LFLAGS_USR+=


#=============================================================================
# CXXFLAGS_USR lists the compilation flags specific for your library/device/exe
# This is the place where to put your compile-time macros using '-Dmy_macro'
#
# -DACE_HAS_EXCEPTIONS -D__ACE_INLINE__ for ACE
#
CXXFLAGS_USR+= -std=c++11


#=============================================================================
# TANGO_REQUIRED 
# - TRUE  : your project depends on TANGO
# - FALSE : your project does not depend on TANGO
#-----------------------------------------------------------------------------
# - NOTE : if PROJECT_TYPE is set to DEVICE, TANGO will be auto. added
#-----------------------------------------------------------------------------  
TANGO_REQUIRED = TRUE



#=============================================================================
#	include Standard TANGO compilation options
#
include $(MAKE_ENV)/tango.opt

#=============================================================================
#	POST_PROCESSING: action to be done after normal make.
#	e.g.:  change executable file name, .....
#POST_PROCESSING = \
#	mv bin/$(BIN_DIR)/$(PACKAGE_NAME) bin/$(BIN_DIR)/$(PACKAGE_NAME)_DS

#=============================================================================
# SVC_OBJS is the list of all objects needed to make the output
#
SVC_INCL =  $(PACKAGE_NAME).h $(PACKAGE_NAME)Class.h 


SVC_OBJS =      \
		$(LIB_OBJS) \
		$(OBJDIR)/ClassFactory.o  \
        $(OBJDIR)/main.o

LIB_OBJS = \
        $(OBJDIR)/$(PACKAGE_NAME).o \
        $(OBJDIR)/$(PACKAGE_NAME)Class.o \
        $(OBJDIR)/$(PACKAGE_NAME)StateMachine.o \
        $(ADDITIONAL_OBJS) 

SVC_INHERITANCE_OBJ =  \


#=============================================================================
#	include common targets
#
include $(MAKE_ENV)/common_target.opt

=== debian/changelog ===
pytango (9.3.6-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Really fix the tests suite on IPv6-only buildds. (Closes: #1030297)

 -- Helmut Grohne <helmut@subdivi.de>  Tue, 21 Feb 2023 15:38:03 +0100

pytango (9.3.6-2) unstable; urgency=medium

  * Team upload.
  * Patch: Python 3.11 support. (Closes: #1024078)
  * Build-Depend on python3-pytest-forked instead of xdist. (It replaced the
    --boxed option)
  * Patch: Use --forked instead of --boxed.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 24 Dec 2022 16:15:45 -0400

pytango (9.3.6-1) unstable; urgency=medium

  [ Sandor Bodo-Merle ]
  * debian/patches
     - add patch to avoid test failure on IPv6 only buildd (Closes: #1014179)
  * d/control: build depend on cppzmq-dev (Closes: #1019091)
  * New upstream version 9.3.6

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 15 Oct 2022 15:01:09 +0200

pytango (9.3.4-2) unstable; urgency=medium

  * d/t/control: added python3-pytest-forked as explained by the upstream

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 01 Jul 2022 16:01:09 +0200

pytango (9.3.4-1) unstable; urgency=medium

  [ Sandor Bodo-Merle ]
  * debian/control:
    - update standars version to 4.6.1 (no changes required)
  * New upstream version 9.3.4
  * debian/patches
     - Drop 0002-deal-with-sphinx-only-via-the-debian-rules.patch
     - Drop 0003-doc-update-start-page.patch
     - Drop 0004-fix-syntax-warning.patch

  [ Picca Frédéric-Emmanuel ]
  * d/control: Moved sphinx-common to B-D-I and added <!nodoc> profile
  * d/control: Added python3-psutil <!nocheck> and tango-test <!nocheck>
  * d/rules: Run tests using pytest
  * Added autopkgtests

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 23 Jun 2022 18:29:29 +0200

=== debian/control ===
Source: pytango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Sandor Bodo-Merle <sbodomerle@gmail.com>,
Section: science
Priority: optional
Build-Depends:
 cppzmq-dev,
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-numpy3,
 dh-sequence-python3,
 libboost-python-dev,
 libtango-dev,
 pkg-config,
 python3-all-dev,
 python3-gevent,
 python3-numpy,
 python3-psutil <!nocheck>,
 python3-pytest <!nocheck>,
 python3-pytest-forked <!nocheck>,
 python3-setuptools,
 python3-six,
 tango-test <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 graphviz <!nodoc>,
 python3-mock <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 sphinx-common <!nodoc>,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/pytango
Vcs-Git: https://salsa.debian.org/science-team/pytango.git
Homepage: https://pytango.readthedocs.io/en/latest/
Rules-Requires-Root: no

Package: python3-tango
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
Description: API for the TANGO control system (Python 3)
 TANGO is an object oriented distributed control system using CORBA,
 mainly developed by the Controls Section of the ALBA Synchrotron.
 PyTango provides bindings for its client- and server-side C++ APIs.
 With PyTango, you can write TANGO device servers and TANGO applications
 (scripts, CLIs, GUIs) that access TANGO device servers in pure Python.
 .
 This is the Python 3 version of the package.

Package: python-tango-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Breaks:
 python-pytango-doc (<< 9.2.0-2~),
Replaces:
 python-pytango-doc (<< 9.2.0-2~),
Description: API for the TANGO control system
 TANGO is an object oriented distributed control system using CORBA,
 mainly developed by the Controls Section of the ALBA Synchrotron.
 PyTango provides bindings for its client- and server-side C++ APIs.
 With PyTango, you can write TANGO device servers and TANGO applications
 (scripts, CLIs, GUIs) that access TANGO device servers in pure Python.
 .
 This package contains the documentation for the python-tango library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tango

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_clean:
	rm -rf build
	rm -rf *.egg-info
	rm -rf build

execute_after_dh_auto_build-indep:
	dh_auto_build -- -s custom --build-args="PYTHONPATH={build_dir} {interpreter} -m sphinx -N -bhtml doc build/html"

override_dh_auto_test:
	PATH="/usr/lib/tango/:$$PATH" dh_auto_test

execute_after_dh_installdocs-indep:
	dh_installdocs -p python-tango-doc "build/html"
	dh_installdocs -p python-tango-doc "examples"

=== debian/tests/control ===
Test-Command: set -efu
 ; cp  -r tests "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; PATH=/usr/lib/tango/:$PATH $py -m pytest tests -v --forked
 ; done
Depends:
 python3-all,
 python3-psutil,
 python3-pytest,
 python3-pytest-forked,
 python3-tango,
 tango-test,
Restrictions: allow-stderr, skip-not-installable, isolation-container

Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import tango; print(tango.Database().get_info())"
 ; done
Depends:
 default-mysql-server,
 python3-all,
 python3-tango,
 tango-db
Restrictions: allow-stderr, skip-not-installable, isolation-container

## pytango 9.4.1

=== debian/changelog ===
pytango (9.4.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 9.4.1
  * d/patches:
    - Update 0001-Use-jquery-from-the-archive.patch
    - Update 0002-Added-gevent-to-instal_requires.patch
    - Remove 0004-Fix-python-3.11-compatibility.patch, applied upstream
    - Remove 0005-Replace-pytest-xdist-with-pytest-forked.patch, applied
      upstream
    - Update ftbfs-ipv6.patch
    - Add test-timeouts.patch to incrase test timeouts and avoid building
      failures
    - Add remove-junitxml-report.patch to make lintian happier
  * Set RELEASE to experimental in debian/salsa-ci.yml
  * Add lintian overrides about source-is-missing of ipython_db.html
  * Versioned Build-Dep on libtango-dev and tango-test (>= 9.4.2~rc2+dfsg1)
  * Add d/copyright data about coroutine() in tango/asyncio_tools.py

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 08 Jun 2023 10:34:09 -0300

## pytango 9.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,13 @@
-cmake_minimum_required(VERSION 3.0.2)
+cmake_minimum_required(VERSION 3.7 FATAL_ERROR)
 set(CMP0048 NEW)
+project(_tango LANGUAGES CXX)
 
-project(_tango LANGUAGES CXX)
+if(NOT DEFINED CMAKE_CXX_STANDARD)
+    set(CMAKE_CXX_STANDARD 14)
+endif()
+
+set(CMAKE_CXX_EXTENSIONS OFF)
+set(CMAKE_STANDARD_REQUIRED YES)
 
 # Set PROJECT_VERSION and PACKAGE_VERSION from git tags
 include(cmake/project_version.cmake)
@@ -21,12 +27,9 @@
 if(CMAKE_SIZEOF_VOID_P EQUAL 8)
   set(PY_TARGET "64")
   add_definitions(-D_64BITS)
-  if(MSVC14)
-    add_definitions(-D_TIMERS_T_)
-  endif(MSVC14)
+  add_definitions(-D_TIMERS_T_)
 elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
   set(PY_TARGET "32")
-  add_definitions(-DJPG_USE_ASM)
 else(CMAKE_SIZEOF_VOID_P EQUAL 8)
   message(FATAL_ERROR "Unknown architecture - aborting!")
 endif(CMAKE_SIZEOF_VOID_P EQUAL 8)
@@ -126,25 +129,17 @@
         ext/tgutils.h
         ext/to_py.h)
 
-set(${PROJECT_NAME} INCLUDE_DIRS "$ENV{TANGO_ROOT}/include")
-
-if(MSVC90)
-  # v9 used for Python 2
-  set(VCSTR "90")
-  set(BOOST_VERSION_ "1_70")
-elseif(MSVC14)
-  # v14 used for Python 3
-  set(VCSTR "140")
-  set(BOOST_VERSION_ "1_73")
-endif()
+set(BOOST_VCSTR "142")
+set(BOOST_VERSION_ "1_82")
+set(ZMQ_VCSTR "141")
 set(ZMQ_VERSION_ "4_0_5")
 
 set(RELEASE "Release_$ENV{PYTHON_VER}_${PY_TARGET}")
-include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/ext")
-include_directories(${PROJECT_NAME} PUBLIC "$ENV{BOOST_ROOT}/include/boost-${BOOST_VERSION_}")
-include_directories(${PROJECT_NAME} PUBLIC "$ENV{PYTHON_ROOT}/include")
-include_directories(${PROJECT_NAME} PUBLIC "$ENV{TANGO_ROOT}/include")
-include_directories(${PROJECT_NAME} PUBLIC "$ENV{PYTHON_ROOT}/Lib/site-packages/numpy/core/include")
+include_directories("${CMAKE_CURRENT_SOURCE_DIR}/ext")
+include_directories("$ENV{TANGO_ROOT}/include")
+include_directories("$ENV{PYTHON_ROOT}/include")
+include_directories("$ENV{BOOST_ROOT}/include/boost-${BOOST_VERSION_}")
+include_directories("$ENV{PYTHON_ROOT}/Lib/site-packages/numpy/core/include")
 link_directories("$ENV{TANGO_ROOT}/bin")
 link_directories("$ENV{TANGO_ROOT}/lib")
 link_directories("$ENV{PYTHON_ROOT}/libs")
@@ -168,11 +163,6 @@
   LIBRARY_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}/tango"
   RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_SOURCE_DIR}/${RELEASE}/tango")
 
-if(MSVC90 AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
-  # resolve VC 9 64bits complains
-  set_source_files_properties(ext/base_types.cpp PROPERTIES COMPILE_FLAGS /bigobj)
-endif()
-
 add_custom_command(TARGET ${PROJECT_NAME}
   POST_BUILD
   COMMAND "$ENV{PYTHON_ROOT}/python.exe"  ARGS "${CMAKE_CURRENT_SOURCE_DIR}/winsetup.py" ${RELEASE} dist temp_dist $(ConfigurationName) $(PlatformName)
@@ -186,14 +176,13 @@
 set_property(TARGET ${PROJECT_NAME} PROPERTY COMPILE_OPTIONS "/bigobj")
 set_property(TARGET ${PROJECT_NAME} PROPERTY COMPILE_OPTIONS "/MT")
 set_property(TARGET ${PROJECT_NAME} PROPERTY LINK_FLAGS "/LTCG /force:multiple /DYNAMICBASE:NO /OPT:REF /OPT:ICF /SUBSYSTEM:WINDOWS")
-target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
 target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/libtango.lib
                                              $ENV{TANGO_ROOT}/lib/omniORB4.lib
                                              $ENV{TANGO_ROOT}/lib/omniDynamic4.lib
                                              $ENV{TANGO_ROOT}/lib/COS4.lib
-                                             $ENV{TANGO_ROOT}/lib/omnithread.lib)
+                                             $ENV{TANGO_ROOT}/lib/omnithread.lib
+                                             $ENV{TANGO_ROOT}/lib/libzmq-v${ZMQ_VCSTR}-mt-s-${ZMQ_VERSION_}.lib
+                                             $ENV{TANGO_ROOT}/lib/jpeg-static.lib)
 target_link_libraries(${PROJECT_NAME} PUBLIC ws2_32 mswsock advapi32 comctl32 odbc32)
-target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/pthreadVC2.lib)
-target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{TANGO_ROOT}/lib/libzmq-v${VCSTR}-mt-s-${ZMQ_VERSION_}.lib)
-target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{BOOST_ROOT}/lib/libboost_python$ENV{PYTHON_VER}-vc${VCSTR}-mt-s-x${PY_TARGET}-${BOOST_VERSION_}.lib)
+target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{BOOST_ROOT}/lib/libboost_python$ENV{PYTHON_VER}-vc${BOOST_VCSTR}-mt-s-x${PY_TARGET}-${BOOST_VERSION_}.lib)
 target_link_libraries(${PROJECT_NAME} PUBLIC $ENV{PYTHON_ROOT}/libs/python$ENV{PYTHON_VER}.lib)

=== debian/changelog ===
pytango (9.4.2-1) unstable; urgency=low

  * Team upload.
  * New upstream version 9.4.2

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 11 Aug 2023 10:54:08 -0300

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  dh-sequence-numpy3,
  dh-sequence-python3,
  libboost-python-dev,
- libtango-dev,
+ libtango-dev (>= 9.4.2~rc2+dfsg1),
  pkg-config,
  python3-all-dev,
  python3-gevent,
@@ -22,7 +22,7 @@
  python3-pytest-forked <!nocheck>,
  python3-setuptools,
  python3-six,
- tango-test <!nocheck>,
+ tango-test (>= 9.4.2~rc2+dfsg1) <!nocheck>,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nodoc>,
  graphviz <!nodoc>,
